/********************************
  Little John, a NES emulator.
  File : unes_loadzip.c
  Authors : Yoyo.
  Version : 0.3
  Last update : 3rd Mai 2000
********************************/

#include "unes.h"
#include "unzip.h"
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>

char Load_ZIPROM(char *zipname)
{
  char tmp[2];
  unzFile file;
  char filename[132];
  int filesize = 0;
  int port;
  unz_file_info info;
  char name[132];
  int len;
  char *ext;
  byte *ptr;
  byte more;
  int FileSize,TotalFileSize,headers;
  int calc_size;
  int l;
  FILE *f;
  

  TotalFileSize = 0;
  headers = 0;
    
  file = unzOpen(zipname);
  if(file == NULL)
    return (TRUE);

  printf("Reading zipfile: %s\n",zipname);

  // find largest file in zip file (under MAX_ROM_SIZE)
  // or a file with extension .nes
  port = unzGoToFirstFile(file);
  
  while(port == UNZ_OK)
    {
      
      unzGetCurrentFileInfo(file, &info, name,128, NULL,0, NULL,0);
      //printf("zipfile: %s    size: %d\n",name,info.uncompressed_size);

      if(info.uncompressed_size > filesize)
	{
	  strcpy(filename,name);
	  filesize = info.uncompressed_size;
	}
      len = strlen(name);
      if( (name[len-4] == '.') && ((name[len-3] == 'n')||(name[len-3] == 'N')) && ((name[len-2] == 'e')||(name[len-2] == 'E')) && ((name[len-1] == 's')||(name[len-1] == 'S')))
	{
	  strcpy(filename,name);
	  filesize = info.uncompressed_size;
	  break;
	}
      port = unzGoToNextFile(file);
    }
  if( !(port == UNZ_END_OF_LIST_OF_FILE || port == UNZ_OK) || filesize == 0)
    {
      assert( unzClose(file) == UNZ_OK );
      return (TRUE);
    }

  // Find extension
  
  tmp[0] = tmp[1] = 0;
  ext = strrchr(filename,'.');
  if(ext) ext++;
  else ext = tmp;

    
  unzLocateFile(file,filename,1);
  unzGetCurrentFileInfo(file, &info, filename,128, NULL,0, NULL,0);
    
  if( unzOpenCurrentFile(file) != UNZ_OK )
    {
      unzClose(file);
      printf("Error in zip file\n");
      return (TRUE);
    }

  FileSize = romsize = info.uncompressed_size;

  Vnes.rom=(byte *)malloc(romsize);
	
  printf("Unzipping %s, filesize : %d\n",filename,FileSize);
      
  l = unzReadCurrentFile(file,Vnes.rom,FileSize);
  if(unzCloseCurrentFile(file) == UNZ_CRCERROR)
    {
      unzClose(file);
      printf("CRC error in zip file.\n");
      return (TRUE);
    }
      
  if(l <= 0 || l != FileSize)
    {
      unzClose(file);
      printf("Error in zip file.%d\n",l);
      switch(l)
	{
	case UNZ_ERRNO:
	  printf("Errno:...\n");
	  break;
	case UNZ_EOF:
	  printf("Unexpected end of file.\n");
	  break;
	case UNZ_PARAMERROR:
	  printf("Parameter error.\n");
	  break;
	case UNZ_BADZIPFILE:
	  printf("Bad zipfile.\n");
	  break;
	case UNZ_INTERNALERROR:
	  printf("Internal error.\n");
	  break;
	case UNZ_CRCERROR:
	  printf("CRC error.\n");
	  break;
	}
      return (TRUE);
    }

    printf("Unzipping ok\n");

  /*  printf("Do it %d\n",romsize);
      f=fopen("/tmp/dump","wb");
      if (f)
      {
      fwrite(Vnes.rom,1,romsize,f);
      fclose(f);
      }
      else printf("Cannot open file for dump\n");*/
  

      
  unzClose(file);

  return (FALSE);
}
